/// <reference types="node" />

import { GlobOptions } from 'glob';
import Stream from 'node:stream';

/**
 * Find files using a glob pattern to get a string or stream of
 * the combined files' content.
 * @see {@link https://www.npmjs.com/package/glob}
 */
export declare function globcat(patterns: string | string[], options: GlobcatOptions & {
    stream: false;
}, callback: GlobcatCallback<string>): void;

export declare function globcat(patterns: string | string[], options: GlobcatOptions & {
    stream: true;
}, callback: GlobcatCallback<Stream.Readable>): void;

export declare function globcat(patterns: string | string[], callback: GlobcatCallback<string>): void;

export declare function globcat(patterns: string | string[], options?: GlobcatOptions & {
    stream: false;
}): Promise<string>;

export declare function globcat(patterns: string | string[], options: GlobcatOptions & {
    stream: true;
}): Promise<Stream.Readable>;

export declare type GlobcatCallback<T extends string | Stream.Readable> = (err: Error | null, result?: T) => void;

export declare interface GlobcatOptions {
    glob?: GlobOptions;
    stream?: boolean;
}

export { }
